//+------------------------------------------------------------------+
//|                                       PipeTrader_FI_Strategy.mq4 |
//|                                        Copyright  2007 omelette |
//|                                    http://omelette@oceanfree.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 omelette"
#property link      "http://omelette@oceanfree.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_level1 0.03
#property indicator_level2 -0.03
#property indicator_levelcolor Gray
//---- input parameters
extern bool Alerts_On = true;
extern double Alert_Trigger_Level = 0.03;
extern bool FI_DisplayValue_On = true;
extern int FI_Value_X = 930;
extern int FI_Value_Y = 40;
extern int ExtForcePeriod=13;
extern int ExtForceMAMethod=0;
extern int ExtForceAppliedPrice=0;

//---- buffers
double ExtForceBuffer[],FIBuyArrow[],FISellArrow[],CloseTrade[];
int ArrowNum;
bool EntryAllowed,CloseOrderFlag,WatchFlag;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(1);
   string sShortName;
   SetIndexBuffer(0,ExtForceBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
//---- name for DataWindow and indicator subwindow label
   sShortName="Force("+ExtForcePeriod+")";
   IndicatorShortName(sShortName);
   SetIndexLabel(0,sShortName);
//---- first values aren't drawn
   SetIndexDrawBegin(0,ExtForcePeriod);
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
  for (int shift=Bars-2;shift>=0;shift--)
   {
      ObjectDelete("Trade_Arrow"+shift);
      ObjectDelete("Wealth"+shift);
   } 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Force Index indicator                                            |
//+------------------------------------------------------------------+
int start()
  {
   int nLimit,nCountedBars=IndicatorCounted();
   bool StepMAcheck,ValidBuyOrder,ValidSellOrder,OneBarVolatCheck,EmergencyClose;
//---- insufficient data
   IndicatorShortName("PipeTrader_FI");
   if(Bars<=ExtForcePeriod) return(0);
   else nCountedBars++;
   nLimit=Bars-nCountedBars;
//---- Force Index counted
   for(int i=nLimit; i>=0; i--)
   {
    ExtForceBuffer[i]=Volume[i]*(iMA(NULL,0,ExtForcePeriod,0,ExtForceMAMethod,ExtForceAppliedPrice,i)
                               -iMA(NULL,0,ExtForcePeriod,0,ExtForceMAMethod,ExtForceAppliedPrice,i+1));
      
    StepMAcheck = (iCustom(NULL,0,"StepMA_Stoch_v1.2",7,1,500,0,0,i+1) > iCustom(NULL,0,"StepMA_Stoch_v1.2",7,1,500,0,1,i+1));  
    ValidBuyOrder = (StepMAcheck && ExtForceBuffer[i] > Alert_Trigger_Level && ExtForceBuffer[i + 1] > Alert_Trigger_Level);
    ValidSellOrder = (!StepMAcheck && ExtForceBuffer[i] < -Alert_Trigger_Level && ExtForceBuffer[i + 1] < -Alert_Trigger_Level);
    OneBarVolatCheck = ((ExtForceBuffer[i + 1] > Alert_Trigger_Level && ExtForceBuffer[i] < -Alert_Trigger_Level)
                       || (ExtForceBuffer[i + 1] < -Alert_Trigger_Level && ExtForceBuffer[i] > Alert_Trigger_Level));
    if (FI_DisplayValue_On)
    {
     if (ExtForceBuffer[i] > 0)
      int NumColour = Blue;
     else NumColour = Red;
    
     ObjectDelete("PipeValue");  
     ObjectCreate("PipeValue", OBJ_LABEL, WindowFind("PipeTrader_FI"), 0, 0);
     ObjectSet("PipeValue", OBJPROP_CORNER, 0);
     ObjectSet("PipeValue", OBJPROP_XDISTANCE, FI_Value_X);
     ObjectSet("PipeValue", OBJPROP_YDISTANCE, FI_Value_Y);  
     ObjectSetText("PipeValue",DoubleToStr(ExtForceBuffer[i],4),22, "Arial Bold", NumColour);
    }
   if (i > 0) {
    if (MathAbs(ExtForceBuffer[i]) > Alert_Trigger_Level) {
     if (OneBarVolatCheck && !EntryAllowed) {
      CloseOrderFlag = true;
      WatchFlag = false;
      EmergencyClose = true; }
     else EmergencyClose = false;
     if (Alerts_On && i == 1 && WatchFlag == true
        && ((StepMAcheck && ExtForceBuffer[i] > Alert_Trigger_Level) || (!StepMAcheck && ExtForceBuffer[i] < -Alert_Trigger_Level))) {
      PlaySound("watch.wav");
      WatchFlag = false; }
     if (EntryAllowed) {
      CloseOrderFlag = true;
      if (ValidBuyOrder || ValidSellOrder) {
       if (ValidBuyOrder) {
        ObjectCreate("Trade_Arrow"+ArrowNum, OBJ_ARROW, 0, Time[i], Low[iLowest(NULL,0,MODE_LOW,3,i)]); 
        ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
        ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_COLOR, Blue); }
       else if (ValidSellOrder) {
        ObjectCreate("Trade_Arrow"+ArrowNum, OBJ_ARROW, 0, Time[i], High[iHighest(NULL,0,MODE_HIGH,3,i)]); 
        ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
        ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_COLOR, Red); }
      ArrowNum++;
      EntryAllowed = false;
      if (Alerts_On && i == 1) {
       Alert("ForceIndex threshold  exceeded... (",GetCurrentTF(Period())," ",Symbol(),")");
      if (ValidBuyOrder)
       PlaySound("buy.wav");
      else if (ValidSellOrder)
       PlaySound("sell.wav"); } } }
     else if (CloseOrderFlag
          && (ExtForceBuffer[i] > 0 && ExtForceBuffer[i] < ExtForceBuffer[i + 1] && ExtForceBuffer[i + 1] < ExtForceBuffer[i + 2])
          || (ExtForceBuffer[i] < 0 && ExtForceBuffer[i] > ExtForceBuffer[i + 1] && ExtForceBuffer[i + 1] > ExtForceBuffer[i + 2])
          || EmergencyClose) {
       ObjectCreate("Trade_Arrow"+ArrowNum, OBJ_ARROW, 0, Time[i], (High[i]+Low[i]) / 2); 
       ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_ARROWCODE, 251);
       ObjectSet("Trade_Arrow"+ArrowNum, OBJPROP_COLOR, Brown);
       ArrowNum++;
       CloseOrderFlag = false;
       if (EmergencyClose)
        EntryAllowed = true;
       EmergencyClose = false;
       if (Alerts_On && i == 1) {
        Alert("ForceIndex - Close Order Recommendation... (",GetCurrentTF(Period())," ",Symbol(),")");
        PlaySound("close.wav"); } } }
    else { EntryAllowed = true;
     WatchFlag = true; } }
   
   }
//---- done
   return(0);
  }
  
  string GetCurrentTF(int Prd)
  {
   string temp;
   
   switch(Prd) {
    case 1: temp = "M1"; break;
    case 5: temp = "M5"; break;
    case 15: temp = "M15"; break;
    case 30: temp = "M30"; break;
    case 60: temp = "H1"; break;
    case 240: temp = "H4"; break;
    case 1440: temp = "D1"; break;
    case 10080: temp = "W1"; break;
    case 43200: temp = "M1"; break; }
    
   return(temp);
   
   }
//+------------------------------------------------------------------+